#!/usr/local/bin/perl -w

require "../globalVariables";
require "../Rweb.pm";

$identifier = $$;
&createTempFiles;  	# For data, output, ...

&ReadParse;
$time = time();

$dataInput = bringInData (\%in);
&inputStuff($dataInput);
	
if ( $LOGFILE ) {
open (logFile, ">> log.ANOVA");
print logFile "Host:$ENV{'REMOTE_HOST'}%Address:$ENV{'REMOTE_ADDR'}%Browser:$ENV{'HTTP_USER_AGENT'}%Time:$time\n";
close(logFile);
}

print "Content-type: text/html\n\n";

print "<H1> ANOVA Results </H1>";

print "<PRE> \n";

## open up the file for storing the R code
open (RoutFile, "> $FCode");
select(RoutFile); # it's now the default for printing
print ("postscript(file= \"$FOutputPS\", height = 6, width = 8)\n");
print("$input{'code'} \n"); # code to load and setup data

############################################################
####### Write out the R code for the analysis

# Check for response and factors before running analysis
if (defined($in{'response'}) && defined($in{'factor'})){
    $response = $in{'response'};
    $factors = $in{'factor'};
    @factors = split(/, /, $factors);
    $formula = $factors;
# error checking
    if ($factors =~ /$response/){
	print STDOUT "<H2>You shouldn't include the response as a factor!</H2>";
	close(RoutFile);
	&RwebExit;
	die;
    }
# make sure the factors are of type factor
foreach $var (@factors){
	    print "$var <- as.factor($var) \n";
	}
# include interaction term?
    if (defined($in{'interaction'})){
	$formula =~ s/, /*/g;
    }
    else{$formula =~ s/, / + /g;}
    
# R code for building the analysis object
    print "aov.object <- lm($response ~ $formula) \n";
    
# Print the ANOVA table?
    if (defined($in{'table'})){
	print "anova(aov.object) \n";
    }
 
# Print the means table?
    if (defined($in{'means'})){
	if ($#factors > 0){
	    print "print(tapply($response, list($factors), mean)) \n";
	}
	foreach $var (@factors){
	    print "print(tapply($response, $var, mean)) \n";
	}
    }
    
# Make the interaction plots?
    if (defined($in{'interactionplot'}) && ($#factors > 0)){
	print "interactionPlot(aov.object) \n";
    }
    
# Multiple Comparisons?
    if (defined($in{'multiplecomparison'}) && ($#factors < 1)){
      print "bonferroni(aov.object) \n";
	#print STDOUT "<H3> Multiple Comparisons not Implemented Yet </H3> \n";
    }
}
else{
    print STDOUT "<H2> You Must choose a response variable and factor(s)</H2>";
}
############################################################
####### end of R code output

close(RoutFile);

###########################################################################
# Now run R in batch mode using the saved commands as the input.
# Output goes into another file that is then read back in and displayed,
# it would be better to do this without the output file but I can't get
# the output to sinc up with the rest of the code ...

&runR;

&printResults;

# Process the postscript file, create gif files and write the necessary code
# into a new Rgif* html file ... this all happens in the $TMPDIR directory
&processPostscript;

&RwebExit;

