#!/usr/local/bin/perl -w

require "../globalVariables";
require "../Rweb.pm";

$identifier = $$;
&createTempFiles;  	# For data, output, ...
&ReadParse;
$time = time();
$dataInput = bringInData (\%in);
&inputStuff($dataInput);

if ( $LOGFILE ) {
open (logFile, ">> log.Regression");
print logFile "Host:$ENV{'REMOTE_HOST'}%Address:$ENV{'REMOTE_ADDR'}%Browser:$ENV{'HTTP_USER_AGENT'}%Time:$time\n";
close(logFile);
}

$goodModel = True;
if (defined($in{'intercept'})){
    $intercept ="T";
    }
else{$intercept = "F";}

print "Content-type: text/html\n\n";

print "<H1> Regression Results </H1>";


####### check for response/predictor errors
if (defined($in{'response'})){
    $response = $in{'response'};
    if (defined($in{'predictors'})){
	foreach $predictor (split(/, /,$in{'predictors'})){
	    if ($response eq $predictor){
      		print("<HR><H1> ERROR </H1> <HR>\n");
		print("You have the response as one of the predictors.\n");
		print("This is not considered good form in Regression.\n");
		print("<HR><H1> ERROR </H1> <HR>\n");
		$goodModel = False;
	    }
	}
    }
    else {
	print("<HR><H1> ERROR </H1> <HR>\n");
	print("You have a response but no predictors ... \n");
	print("It is hard to build a good regression models this way.\n");
	print("<HR><H1> ERROR </H1> <HR>\n");
	$goodModel = False;
    }
} # end of options if response is defined
elsif (defined($in{'predictors'})){
    print("<HR><H1> ERROR </H1> <HR>\n");
    print("You have predictors but no response variable  ...\n");
    print("It is hard to fit an undefined response.\n");
    print("<HR><H1> ERROR </H1> <HR>\n");
    $goodModel = False;
} 
######## end of checks for response/predictor errors. 

# If $goodModel is True you have a good model ... it passed all of the above checks
# Now writeout the R code for whatever options have been selected.

## open up the file for storing the R code
open (RoutFile, "> $FCode");
select(RoutFile); # it's now the default for printing
print ("postscript(file= \"$FOutputPS\", height = 6, width = 8)\n");
print("$input{'code'} \n"); # code to load and setup data

#####all of the coding for the regression Model
if ($goodModel eq 'True'){

    print STDOUT ("<HR><BR><H2> Response: $response</H2> \n");
    print STDOUT ("<H2> Predictors: $in{'predictors'}</H2><BR><HR> \n");

    
    $predictorFormula = $in{'predictors'};
    $predictorFormula =~ s/,/ + /g;

	if (defined($in{'intercept'})){   
    	print("str <- lm($response ~ $predictorFormula) \n");
    	}
    else {print("str <- lm($response ~ $predictorFormula -1) \n");}

    print("residuals <- residuals(str) \n");
    print("predicted <- fitted.values(str) \n");
    print("summary(str) \n");
    
    ## Automatic inclusion of x vs y plots with fitted line
    if (defined($in{'slrplots'})){
    foreach $varname (split(/, /, $in{'predictors'})){
    	print("plot($varname, $response, main=\"SLR Plot of $varname vs $response\") \n");
    	if (defined($in{'intercept'})){ 
    		print("abline(lm($response ~ $varname)) \n");
    		}
    	else {print("abline(lm($response ~ $varname -1)) \n");}
    	}
    	}
    
    ### now check for residual plot requests
    if(defined($in{'resid'})){
	@residplots = split(/, /,$in{'resid'});
	foreach $plot (@residplots){
	    if ($plot eq 'qq') {print("qqnorm(residuals) \nqqline(residuals) \n");}
	    if ($plot eq 'hist') {print("hist(residuals) \n");}
	    if ($plot eq 'predicted') {print("plot(predicted, residuals, main=\"Predicted vs Residual\") \n abline(h=0) \n");}
	}
    }
    
    ### now check for residual versus predictor plots
    if(defined($in{'residvspredictor'})){
	@vars = split(/, /,$in{'residvspredictor'});
	foreach $var (@vars){
	    print("plot($var, residuals, main=\"$var vs Residual\") \n lines(lowess($var, residuals)) \n");
	}
    }
}
##### End of Modeling and residual code

# plot requested histograms
if(defined($in{'hist'})){
    @vars = split(/, /,$in{'hist'});
    foreach $var (@vars){
	print("hist($var) \n");
    }
}

# plot requested scatterplot ... this is done with pairs
# so they get all pairwise scatterplots for requested variables


if(defined($in{'scatterplot'})){
    foreach $varname (split(/, /, $in{'scatterplot'})){
	$varNames .= "\"$varname\", ";
    }
    $varNames =~ s/, $//;  # remove last , and space ... it will screw up R

    print("pairs.var <- data.frame($in{'scatterplot'}) \n");
#    print("dimnames(pairs.var)[[2]] <- c($varNames) \n");
    print("webpairs(pairs.var) \n");
}

close(RoutFile);

###########################################################################
# Now run R in batch mode using the saved commands as the input.
# Output goes into another file that is then read back in and displayed,
# it would be better to do this without the output file but I can't get
# the output to sinc up with the rest of the code ...

&runR;

&printResults;

# Process the postscript file, create gif files and write the necessary code
# into a new Rgif* html file ... this all happens in the $TMPDIR directory
&processPostscript;

&RwebExit;



















