#!/usr/local/bin/perl -w

require "../globalVariables";
require "../Rweb.pm";

$identifier = $$;
&createTempFiles;  	# For data, output, ...

&ReadParse;
$time = time();

$dataInput = bringInData (\%in);
&inputStuff($dataInput);

if ( $LOGFILE ) {
open (logFile, ">> log.Summary");
print logFile "Host:$ENV{'REMOTE_HOST'}%Address:$ENV{'REMOTE_ADDR'}%Browser:$ENV{'HTTP_USER_AGENT'}%Time:$time\n";
close(logFile);
}

if (defined($in{'smoothscatter'})){
    $smoothscatter ="T";
    }
else{$smoothscatter = "F";}

print "Content-type: text/html\n\n";

print "<H1> Summary Results </H1>";

## open up the file for storing the R code
open (RoutFile, "> $FCode");
select(RoutFile); # it's now the default for printing
print ("postscript(file= \"$FOutputPS\", height = 6, width = 8)\n");
print("$input{'code'} \n"); # code to load and setup data

############################################################
####### numerical summaries ... only if we have selected variables
if (defined($in{'analysisvariables'})){
    $variables = $in{'analysisvariables'};
    $analysis = $in{'analysis'};

## R code that lets us just use the R data frame "variables" and everything should
## be labeled properly
    print("variables <- data.frame($variables) \n");

    if ($analysis =~ /fivenumber/){
	print "summary(variables) \n";
	print "var(variables) \n";
    }
    if ($analysis =~ /correlation/){
	print "cor(variables) \n";
    }
} 
############################################################
####### end of numerical summaries

############################################################
####### graphical summaries ... only if we have selected variables

if (defined($in{'graphvariables'})){
    $variables = $in{'graphvariables'};
    @variables = split(/, /, $variables);
    $graphs = $in{'graph'};
    $splitvariable = $in{'split'};
## R code that lets us just use the R data frame "variables" and everything should
## be labeled properly
    print("variables <- data.frame($variables) \n");

## plots that have to be done individually ... at least I can't figure out how
## to do them using pairs
    foreach $var (@variables){
	if ($graphs =~ /histogram/){
	    print "hist($var) \n";
	}
	if ($graphs =~ /qqplotnorm/){
	    print "qqnorm($var) \n";
	    print "qqline($var) \n";
	}
	if ($graphs =~ /timeseries/){
	    print "plot($var, type=\"b\") \n";
	}
	if ($graphs =~ /boxplot/){
	    print "boxplot(split($var, $splitvariable)) \n";
	    print "title(main= \" $var split on $splitvariable \") \n";
	}
    }

## Plots that can be graphed in the pairs format
    if ($graphs =~ /qqplotpair/){
	print "webpairs(variables, panel=function(x1, x2){points(sort(x1),sort(x2))}) \n";
    }
    if ($graphs =~ /scatterplot/){
# check for only one variable ... then do time series plot
	if ($#variables == 0){
	    if (defined($in{'smoothscatter'})){
		print "plot($variables) \n";
		print "lines(lowess(1:length($variables), $variables)) \n";
	    }
	    else {print "plot($variables, type=\"b\") \n";}
	}
	elsif (defined($in{'smoothscatter'})){
	    print "webpairs(variables, panel=function(x,y){points(x,y);lines(lowess(x,y))}) \n";
	}
	else {print "webpairs(variables) \n";}
    }
}
############################################################
####### end of graphical summaries

close(RoutFile);

###########################################################################
# Now run R in batch mode using the saved commands as the input.
# Output goes into another file that is then read back in and displayed,
# it would be better to do this without the output file but I can't get
# the output to sinc up with the rest of the code ...

&runR;

&printResults;

# Process the postscript file, create gif files and write the necessary code
# into a new Rgif* html file ... this all happens in the $TMPDIR directory
&processPostscript;

&RwebExit;


