#!/usr/local/bin/perl -w

require "../globalVariables";
require "../Rweb.pm";

$identifier = $$;
&createTempFiles;  	# For data, output, ...

&ReadParse;
$time = time();

$dataInput = bringInData (\%in);
&inputStuff($dataInput);

if ( $LOGFILE ) {
open (logFile, ">> log.ChiSquare");
print logFile "Host:$ENV{'REMOTE_HOST'}%Address:$ENV{'REMOTE_ADDR'}%Browser:$ENV{'HTTP_USER_AGENT'}%Time:$time\n";
close(logFile);
}

print "Content-type: text/html\n\n";

print "<H1> Two Way Table Results </H1>";

## open up the file for storing the R code
open (RoutFile, "> $FCode");
select(RoutFile); # it's now the default for printing
print ("postscript(file= \"$FOutputPS\", height = 6, width = 8)\n");


if ($in{'Table'}){
   print STDOUT "Using User Defined Table  <BR>\n";

   $tableData = $in{'Table'};
   $rowNames = $in{'rowNames'};
   $colNames = $in{'colNames'};

   $tableData =~ s/,/ /g;
   $tableData =~ s/\s+/, /g;
   chomp($tableData);
#   print "$tableData <BR>\n";

   $rowNames =~ s/,/ /g;
   $rowNames =~ s/(\S+)/\"\1\"/g;
   $rowNames =~ s/\s+/, /g;
   chomp($rowNames);
#   print "$rowNames <BR>\n";

   $colNames =~ s/,/ /g;
   $colNames =~ s/(\S+)/\"\1\"/g;
   $colNames =~ s/\s+/, /g;
   chomp($colNames);
#   print "$colNames <BR>\n";

   $count = split /,/, $colNames;

   print "inputTable <- matrix(c($tableData), ncol = $count, byrow=T) \n";
   print "rownames(inputTable) <- c($rowNames) \n";
   print "colnames(inputTable) <- c($colNames) \n";
#   print "inputTable \n";
   print "twoWayOutput <- twoWay(userDefined = inputTable) \n ";
}
else {
  print("$input{'code'} \n"); # code to load and setup data
  print "twoWayOutput <- twoWay(x = $in{'rowVariable'}, y = $in{'colVariable'}) \n ";
}

############ Options for which tables to print

if (defined($in{'observed'})) {
    print "printIt(twoWayOutput\$fA, \"Table of Observed Values and Marginal Totals\") \n";
}
if (defined($in{'expected'})) {
    print "printIt(twoWayOutput\$e, \"Table of Expected Values\") \n";
}
if (defined($in{'chisq'})) {
    print "printIt(twoWayOutput\$ct, \"Table of Chi-Square Values\") \n";
}
if (defined($in{'percent'})) {
    print "printIt(100*twoWayOutput\$p, \"Table of Percents\") \n";
}
if (defined($in{'row'})) {
    print "printIt(100*twoWayOutput\$rp, \"Table of Row Percents\") \n";
}
if (defined($in{'col'})) {
    print "printIt(100*twoWayOutput\$cp, \"Table of Column Percents\") \n";
}

close(RoutFile);
###########################################################################
# Now run R in batch mode using the saved commands as the input.
# Output goes into another file that is then read back in and displayed,
# it would be better to do this without the output file but I can't get
# the output to sinc up with the rest of the code ...

&runR;

&printResults;

# Process the postscript file, create gif files and write the necessary code
# into a new Rgif* html file ... this all happens in the $TMPDIR directory
&processPostscript;

&RwebExit;
