#!/usr/local/bin/perl -w

# This script builds the Rweb Module page. It accesses the DataSets
# subdirectory under the directory containing the cgi scripts.

require "globalVariables";
require "Rweb.pm";

print << "ending_print_tag";
Content-type: text/html


<title>Rweb Modules</title>
<IMG SRC="http://$SERVER/$RWEBDIR/RwebLogo.GIF" ALT="Great Rweb Logo">

<H2>Welcome to Rweb Modules</H2>

<P>
This is the main Rweb module page.
The Rweb modules are a set of point and click interfaces to the
statistical programming language R.
There are several built in datasets which are briefly described below.
Following the dataset descriptions are two drop down menus.
One allows you to choose the type of analysis you want and, with the other
menu, you can choose the data set you want to use.
You may use any of the built in data sets, a Web accessable data set (you
need to supply the URL), or you may enter your own data.
The options for using your own data are at the bottom of the 
dataset menu and the text areas for entering a URL or data follow the
drop down menus.
Once you have chosen an analysis and dataset click the submit button
to build the analysis page.
</P>

ending_print_tag

## Reading in the analyses ############
@analysisFiles = glob("AnalysisModules/setup*");

foreach $file (@analysisFiles){
    $file =~  s/^AnalysisModules\/setup//;
}

## Reading in the datasets ############
@inputFiles = glob("DataSets/*.input");

foreach $file (@inputFiles){
    $file =~  s/.input$//;			     # Cleanup the file names ... remove .input
    $file =~  s/^DataSets\///;
    $description{$file} = &inputStuff("DataSets/$file.input");
}

## Printing to the Returned page ############
print "<H2>Data Set Descriptions</H2>\n";

print "<DL>\n";
foreach $file (@inputFiles){
    print("<DT>  <B>$file</B> \n");
    print("<DD> $description{$file}");
}
print "</DL>\n";

print << "ending_print_tag";

<H2>Choose Analysis and Data Set</H2>

<FORM ACTION=\"http://$SERVER/$CGIDIR/buildAnalysisPage.cgi\" METHOD=\"POST\">

<TABLE>
<TR>
    <TH>Analysis Menu</TH>
    <TH>Data Set Menu</TH>

</TR>


<TR>

    <TD>
    <SELECT NAME="analysis">

ending_print_tag

	foreach $file (@analysisFiles){
    	print("<OPTION value=\"$file\"> $file </OPTION> \n");
	}

print << "ending_print_tag";

    </SELECT>
    </TD>
    
    <TD>
       <SELECT NAME="dataname">

ending_print_tag

	foreach $file (@inputFiles){
    	print("<OPTION value=\"$file\"> $file </OPTION> \n");
	}

print << "ending_print_tag";
<OPTION VALUE="URLdata">Use Remote Data Set(enter URL below)</OPTION>
<OPTION VALUE="Userdata">User Supplied Data(enter Data below)</OPTION>
    </SELECT>

    </TD>
    </TR>

    </TABLE>

    <inPUT TYPE=\"submit\" VALUE=\"Submit\">
    <Input TYPE=\"reset\" VALUE=\"Reset \">

    <H3>URL for Web Accessable Dataset</H3>
    Remote Dataset URL: 
    <INPUT TYPE="TEXT" NAME="Data" SIZE=50 Value="$dataURL">
    <BR>
    <H3>Type in Your Own Data</H3>
    <P>
    Enter user supplied data in the following text area.
    The first line must contain the variable names and then each
    observation should be entered as a single row.
    You may seperate entries with spaces or tabs.
    Use "NA" for missing values.
    </P>
    Example:
    <PRE>
Site  Oxygen Nitrogen InsectCount
A      3.2    0.12     High
A      1.4    0.22     Low
B       NA    0.55     Medium
    </PRE>
    <BR>
    <TEXTAREA NAME = "UserSuppliedData" COLS=60 ROWS=10></TEXTAREA>
    </FORM>


ending_print_tag

